// from http://blogger.ziesemer.com/2007/10/respecting-javascript-global-namespace.html
//  create a basic namespace for the deskcut object
if (!net) var net = {};
if (!net.evelands) net.evelands={};
if (!net.evelands.deskcutSettings )
{
    net.evelands.deskcutSettings = 
    {
        prefs : Components.classes["@mozilla.org/preferences-service;1"]
                    .getService(Components.interfaces.nsIPrefService)
                    .getBranch("extensions.deskcut."),

        // ------------------------- UI Control -------------------------
        //
        //load up prefs and populate things that don't auto populate
        populatePane: function(pane)
        {
            switch(pane)
            {
                case 1:
                    var nameScheme = this.prefs.getCharPref("nameScheme");
                    var addDate = this.prefs.getBoolPref("addDate");
                    var addDateBefore = this.prefs.getBoolPref("addDateBefore");
                    var dateFormat = this.prefs.getCharPref("dateFormat");
                    var invalidScheme = this.prefs.getCharPref("invalidScheme");
                    var replaceChar = this.prefs.getCharPref("replaceChar");

                    // Select the correct radio button for Name scheme
                    if (nameScheme == "ASK")
                    {
                        document.getElementById('deskcut.promptForFileName').setAttribute('selected', true);
                        document.getElementById('deskcut.pageName').setAttribute('selected', false);
                        document.getElementById('deskcut.pageUrl').setAttribute('selected', false);
                    }
                    else if (nameScheme == "NAME")
                    {
                        document.getElementById('deskcut.pageName').setAttribute('selected', true);
                        document.getElementById('deskcut.promptForFileName').setAttribute('selected',false);
                        document.getElementById('deskcut.pageUrl').setAttribute('selected', false);
                    }
                    else if (nameScheme == "URL")
                    {
                        document.getElementById('deskcut.pageUrl').setAttribute('selected', true);
                        document.getElementById('deskcut.promptForFileName').setAttribute('selected', false);
                        document.getElementById('deskcut.pageName').setAttribute('selected', false);
                    }
                    // Select the correct radio button for dateBefore / dateAfter
                    if (addDateBefore)
                    {
                        document.getElementById('deskcut.dateBefore').setAttribute('selected', true);
                        document.getElementById('deskcut.dateAfter').setAttribute('selected', false);
                    }
                    else
                    {
                        document.getElementById('deskcut.dateBefore').setAttribute('selected', false);
                        document.getElementById('deskcut.dateAfter').setAttribute('selected', true);
                    }

                    // Select the correct radio button for Invalid character behavior
                    if (invalidScheme == "STRIP")
                    {
                        document.getElementById('deskcut.stripBad').setAttribute('selected', true);
                        document.getElementById('deskcut.replaceBad').setAttribute('selected', false);
                        document.getElementById('deskcut.encodeBad').setAttribute('selected', false);
                    }
                    else if (invalidScheme == "REPLACE")
                    {
                        document.getElementById('deskcut.stripBad').setAttribute('selected', false);
                        document.getElementById('deskcut.replaceBad').setAttribute('selected', true);
                        document.getElementById('deskcut.encodeBad').setAttribute('selected', false);
                    }
                    else if (invalidScheme == "ENCODE")
                    {
                        document.getElementById('deskcut.stripBad').setAttribute('selected', false);
                        document.getElementById('deskcut.replaceBad').setAttribute('selected', false);
                        document.getElementById('deskcut.encodeBad').setAttribute('selected', true);
                    }

                    // now call the sub functions to grey out stuff that should be disabled
                    this.addDateCheckbox();
                    //this.stripReplaceBad();
                    // finally update the example text
                    this.updateExample();
                    break;

                case 2:
                    var dirScheme = this.prefs.getCharPref("dirScheme");
                    var deskPath = this.prefs.getCharPref("deskPath");
                    var rememberLast = this.prefs.getBoolPref("rememberLast");

                    if (dirScheme == "ASK")
                    {
                        document.getElementById('deskcut.promptForPathRadioButton').setAttribute('selected', true);
                        document.getElementById('deskcut.setDirectoryRadioButton').setAttribute('selected', false);
                        if (rememberLast)
                            document.getElementById('deskcut.remeberLastCheckbox').setAttribute('checked', true);
                        else
                            document.getElementById('deskcut.remeberLastCheckbox').setAttribute('checked', false);
                    }
                    else if (dirScheme ==  "SET")
                    {
                        document.getElementById('deskcut.promptForPathRadioButton').setAttribute('selected', false);
                        document.getElementById('deskcut.setDirectoryRadioButton').setAttribute('selected', true);
                        document.getElementById('deskcut.remeberLastCheckbox').setAttribute('checked', false);
                        if (!deskPath)
                            deskPath = net.evelands.deskcut.getDesktop();
                    }
                    document.getElementById('deskcut.pathTextBox').value = deskPath;
                    this.dimPathOpts();
                    break;

                case 3:
                    var alertMessagebox = this.prefs.getBoolPref("alertMessagebox");
                    var alertAudio = this.prefs.getBoolPref("alertAudio");
                    //var alertBeep = this.prefs.getBoolPref("alertBeep");
                    var wavPathSuccess = this.prefs.getCharPref("wavPathSuccess");
                    var wavPathFail = this.prefs.getCharPref("wavPathFail");

                    if (alertMessagebox)
                        document.getElementById('deskcut.messagebox').setAttribute('checked', true);
                    else
                        document.getElementById('deskcut.messagebox').setAttribute('checked', false);

                    if (alertAudio)
                        document.getElementById('deskcut.audioAlert').setAttribute('checked', true);
                    else
                        document.getElementById('deskcut.audioAlert').setAttribute('checked', false);

                    document.getElementById('deskcut.wavFileSuccessTextBox').value = wavPathSuccess;
                    document.getElementById('deskcut.wavFileFailTextBox').value = wavPathFail;
                    this.audioAlertChecked();
                    break;

                case 4:
                    var overwriteScheme = this.prefs.getCharPref("overwriteScheme");
                    var makeUnique = this.prefs.getCharPref("makeUniqueScheme");

                    if (overwriteScheme == "ASK")
                    {
                       document.getElementById('deskcut.askRadioButton').setAttribute('selected', true);
                       document.getElementById('deskcut.alwaysOverwrite').setAttribute('selected', false);
                       document.getElementById('deskcut.neverOverwrite').setAttribute('selected', false);
                    }
                    else if (overwriteScheme == "ALWAYS")
                    {
                       document.getElementById('deskcut.askRadioButton').setAttribute('selected', false);
                       document.getElementById('deskcut.alwaysOverwrite').setAttribute('selected', true);
                       document.getElementById('deskcut.neverOverwrite').setAttribute('selected', false);
                    }
                    else if (overwriteScheme == "NEVER")
                    {
                       document.getElementById('deskcut.askRadioButton').setAttribute('selected', false);
                       document.getElementById('deskcut.alwaysOverwrite').setAttribute('selected', false);
                       document.getElementById('deskcut.neverOverwrite').setAttribute('selected', true);
                    }

                    if (makeUnique == "NONE")
                    {
                        document.getElementById('deskcut.makeUnique').setAttribute('checked', false);
                        document.getElementById('deskcut.addNumberButton').disabled = true;
                        document.getElementById('deskcut.addTimestampButton').disabled = true;
                    }

                    else if (makeUnique == "INT")
                    {
                        document.getElementById('deskcut.makeUnique').setAttribute('checked', true);
                        document.getElementById('deskcut.addNumberButton').disabled = false;
                        document.getElementById('deskcut.addTimestampButton').disabled = false;
                        document.getElementById('deskcut.addNumberButton').setAttribute('selected', true);
                        document.getElementById('deskcut.addTimestampButton').setAttribute('selected', false);
                    }
                    else if (makeUnique == "TIMESTAMP")
                    {
                        document.getElementById('deskcut.makeUnique').setAttribute('checked', true);
                        document.getElementById('deskcut.addNumberButton').disabled = false;
                        document.getElementById('deskcut.addTimestampButton').disabled = false;
                        document.getElementById('deskcut.addNumberButton').setAttribute('selected', false);
                        document.getElementById('deskcut.addTimestampButton').setAttribute('selected', true);
                    }


                    break;
            }
        },

        // grey out text box for date format if it's checkbox isn't checked
        addDateCheckbox: function()
        {
            if (document.getElementById('deskcut.addDateCheckBox').getAttribute('checked') == 'true')
            {
                document.getElementById('deskcut.dateFormatMenulist').disabled = false;
                document.getElementById('deskcut.dateBefore').disabled = false;
                document.getElementById('deskcut.dateAfter').disabled = false;
            }
            else
            {
                document.getElementById('deskcut.dateFormatMenulist').disabled = true;
                document.getElementById('deskcut.dateBefore').disabled = true;
                document.getElementById('deskcut.dateAfter').disabled = true;
            }
            this.updateExample();
        },

        // grey out the box for the replace character if it's not selected
        updateRadioButton: function()
        {
            if (document.getElementById('deskcut.stripBad').getAttribute('selected') == 'true' ||
                document.getElementById('deskcut.encodeBad').getAttribute('selected') == 'true' )
            {
                document.getElementById('deskcut.replaceTextBox').disabled = true;
            }
            else if (document.getElementById('deskcut.replaceBad').getAttribute('selected') == 'true')
            {
                document.getElementById('deskcut.replaceTextBox').disabled = false;
            }
            this.updateExample();
        },

        // update the example text
        updateExample: function()
        {
            var outStr = "";
            
            if (document.getElementById('deskcut.pageName').getAttribute('selected') == 'true')
            {
                // attempt to grab title of homepage, default to Google if failure
                outStr = net.evelands.deskcut.getExamplePageTitle();
                if (outStr == '')
                    outStr = "Google";
            }
            else if (document.getElementById('deskcut.pageUrl').getAttribute('selected') == 'true')
            {
                // attempt to grab URL of homepage, default to Google if failure
                outStr = net.evelands.deskcut.getExamplePageUrl();
                if (outStr == '')
                    outStr = "http://www.google.com/";
            }
            else if (document.getElementById('deskcut.promptForFileName').getAttribute('selected') == 'true')
            {
                outStr = "";
            }



            if (document.getElementById('deskcut.addDateCheckBox').getAttribute('checked') == 'true')
            {
                var tDate = new Date();
                var dateFormat = document.getElementById('deskcut.dateFormatMenulist').value;
                var dateTxt = net.evelands.deskcut.formatDate(tDate,dateFormat);
                if (document.getElementById('deskcut.dateBefore').getAttribute('selected') == 'true')
                    outStr = dateTxt + outStr;
                else
                    outStr = outStr + dateTxt;
            }
            if (document.getElementById('deskcut.stripBad').getAttribute('selected') == 'true')
            {
                outStr = net.evelands.deskcut.stripBadChars(outStr);
            }
            else if (document.getElementById('deskcut.replaceBad').getAttribute('selected') == 'true')
            {
                var replaceStr = document.getElementById('deskcut.replaceTextBox').value;
                outStr = net.evelands.deskcut.replaceBadChars(outStr, replaceStr);
            }
            else if (document.getElementById('deskcut.encodeBad').getAttribute('selected') == 'true')
            {
                outStr = net.evelands.deskcut.encodeBadChars(outStr);
            }
            
            document.getElementById('deskcut.dateFormatExample').value = outStr;
        },
        
        validateChar: function()
        {
            var chrToCheck = document.getElementById('deskcut.replaceTextBox').value;
            // first off, only allow length of 1
            if (chrToCheck.length > 1)
            {
                document.getElementById('deskcut.replaceTextBox').value = chrToCheck.substring(0,1);
                this.validateChar(document.getElementById('deskcut.replaceTextBox').value);
            }
            else
            {
                if (net.evelands.deskcut.hasBadChars(chrToCheck) )
                    document.getElementById('deskcut.replaceTextBox').value = '';
                this.updateExample();
            }
        },

        // ---------- tab two stuff ---------
        
        // grey out buttons, opts for the radio buttons not selected
        dimPathOpts: function()
        {
            if (document.getElementById('deskcut.promptForPathRadioButton').getAttribute('selected') == 'true')
            {
                 // first the radio buttons under prompt for path
                 document.getElementById('deskcut.remeberLastCheckbox').disabled = false;
                 // now find desktop button
                 document.getElementById('deskcut.findDesktopButton').disabled = true;
                 // lastly browse for path button
                 document.getElementById('deskcut.browsePathButton').disabled = true;
                 document.getElementById('deskcut.pathTextBox').disabled = true;
            }
            else if (document.getElementById('deskcut.setDirectoryRadioButton').getAttribute('selected') == 'true')
            {
                 // first the radio buttons under prompt for path                
                 document.getElementById('deskcut.remeberLastCheckbox').disabled = true;
                 // now find desktop button
                 document.getElementById('deskcut.findDesktopButton').disabled = false;
                 // lastly browse for path button
                 document.getElementById('deskcut.browsePathButton').disabled = false; 
                 document.getElementById('deskcut.pathTextBox').disabled = false;
            }
           
        },

        findDesktopButtonClick: function()
        {
            var desktop = net.evelands.deskcut.getDesktop();
            document.getElementById('deskcut.pathTextBox').value = desktop;
            document.getElementById('deskPath').valueFromPreferences = desktop;

        },

        browsePathButtonClick: function()
        {
            var title = net.evelands.deskcut.getLocalizedString("browsePathDialogTitle");
            var path = net.evelands.deskcut.browseForPath(title);
            if (path)
            {
                document.getElementById('deskcut.pathTextBox').value = path;
                document.getElementById('deskPath').valueFromPreferences = path;
            }
        },
        
        // ---------- tab three stuff ---------
        

        // disable radiobuttons for audio stuff if not checked
        audioAlertChecked: function()
        {
            if (document.getElementById('deskcut.audioAlert').getAttribute('checked') == 'true')
            {
                document.getElementById('deskcut.browseSuccessWavButton').disabled = false;
                document.getElementById('deskcut.wavFileSuccessTextBox').disabled = false;
                document.getElementById('deskcut.wavFileFailTextBox').disabled = false;
                document.getElementById('deskcut.browseFailWavButton').disabled = false;
                document.getElementById('deskcut.playSuccessWavButton').disabled = false;
                document.getElementById('deskcut.playFailWavButton').disabled = false;
                document.getElementById('deskcut.playSuccessWavButton').setAttribute('image','chrome://deskcut/skin/play.png');
                document.getElementById('deskcut.playFailWavButton').setAttribute('image','chrome://deskcut/skin/play.png');

            }
            else
            {
                document.getElementById('deskcut.browseSuccessWavButton').disabled = true;
                document.getElementById('deskcut.wavFileSuccessTextBox').disabled = true;
                document.getElementById('deskcut.wavFileFailTextBox').disabled = true;
                document.getElementById('deskcut.browseFailWavButton').disabled = true;
                document.getElementById('deskcut.playSuccessWavButton').disabled = true;
                document.getElementById('deskcut.playFailWavButton').disabled = true;
                document.getElementById('deskcut.playSuccessWavButton').setAttribute('image','chrome://deskcut/skin/playDisabled.png');
                document.getElementById('deskcut.playFailWavButton').setAttribute('image','chrome://deskcut/skin/playDisabled.png');

            }
        },

        browseForSuccessWavFile: function()
        {
            var title = net.evelands.deskcut.getLocalizedString("wavSuccessTitle");
            var type = net.evelands.deskcut.getLocalizedString("wavType");
            var path = net.evelands.deskcut.browseForFile(title,type,"*.wav");
            if (path)
            {
                document.getElementById('deskcut.wavFileSuccessTextBox').value = path;
                document.getElementById('wavPathSuccess').valueFromPreferences = path;
            }
        },

        browseForFailWavFile: function()
        {
            var title = net.evelands.deskcut.getLocalizedString("wavFailTitle");
            var type = net.evelands.deskcut.getLocalizedString("wavType");
            var path = net.evelands.deskcut.browseForFile(title,type,"*.wav");
            if (path)
            {
                document.getElementById('deskcut.wavFileFailTextBox').value = path;
                document.getElementById('wavPathFail').valueFromPreferences = path;
            }
        },

        // ---------- tab four stuff ---------

        // grey out makeunique box if neverOverwrite isn't selected
        overwriteRadioButtonClick: function()
        {
            if (document.getElementById('deskcut.askRadioButton').getAttribute('selected') == 'true')
            {
                this.prefs.setCharPref("overwriteScheme","ASK");
            }
            else if (document.getElementById('deskcut.alwaysOverwrite').getAttribute('selected') == 'true')
            {
                this.prefs.setCharPref("overwriteScheme","ALWAYS");
            }
            else if (document.getElementById('deskcut.neverOverwrite').getAttribute('selected') == 'true')
            {
                this.prefs.setCharPref("overwriteScheme","NEVER");
            }
        },

        makeUniqueChecked: function()
        {
            if (document.getElementById('deskcut.makeUnique').getAttribute('checked') == 'true')
            {
                document.getElementById('deskcut.addNumberButton').disabled = false;
                document.getElementById('deskcut.addTimestampButton').disabled = false;
                this.makeUniqueRadioButtonClick();
            }
            else
            {
                document.getElementById('deskcut.addNumberButton').disabled = true;
                document.getElementById('deskcut.addTimestampButton').disabled = true;
                this.prefs.setCharPref("makeUniqueScheme","NONE");
            }
        },

        testFailWavFile: function()
        {
            var sound = Components.classes["@mozilla.org/sound;1"].createInstance();
            if (sound) 
            {
                sound.QueryInterface(Components.interfaces.nsISound);
                sound.init();
         
                var file = Components.classes["@mozilla.org/file/local;1"].
                    createInstance(Components.interfaces.nsILocalFile);
                var pathToFile = document.getElementById('deskcut.wavFileFailTextBox').value
                file.initWithPath (pathToFile);
                if (file.exists())
                {
                    var ioService = Components.classes["@mozilla.org/network/io-service;1"].
                        getService(Components.interfaces.nsIIOService);
                    var url = ioService.newURI("file:///"+pathToFile, "", null);
                    sound.play(url);
                    url = null;
                    ioService = null;
                }
            }
            sound = null;
        },

        testSuccessWavFile: function()
        {
            var sound = Components.classes["@mozilla.org/sound;1"].createInstance();
            if (sound) 
            {
                sound.QueryInterface(Components.interfaces.nsISound);
                sound.init();
         
                var file = Components.classes["@mozilla.org/file/local;1"].
                    createInstance(Components.interfaces.nsILocalFile);
                var pathToFile = document.getElementById('deskcut.wavFileSuccessTextBox').value
                file.initWithPath (pathToFile);
                if (file.exists())
                {
                    var ioService = Components.classes["@mozilla.org/network/io-service;1"].
                        getService(Components.interfaces.nsIIOService);
                    var url = ioService.newURI("file:///"+pathToFile, "", null);
                    sound.play(url);
                    url = null;
                    ioService = null;
                }
            }
            sound = null;
        },

        makeUniqueRadioButtonClick: function()
        {
            if (document.getElementById('deskcut.addNumberButton').getAttribute('selected') == 'true')
            {
                this.prefs.setCharPref("makeUniqueScheme","INT");
            }
            else 
            {
                this.prefs.setCharPref("makeUniqueScheme","TIMESTAMP");
            }
        },
        
    }
}
